
Redmine - Feature #4179

Link to user in wiki syntax

2009-11-08 10:44 - Felix Schäfer

Status: Closed Start date: 2009-11-08

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version: 3.4.0   

Resolution: Fixed   

Description

It would be nice to have some "user" Links in the wiki syntax, something like user:3866 or user:felix, which would the be replaced by

the full name as configured in the global settings, with a link to the user page if the viewing user is entitled to seeing that page.

Related issues:

Related to Redmine - Feature #867: Want more wiki link types Closed 2008-03-15

Related to Redmine - Feature #5228: Users are just numbers Closed 2010-03-31

Related to Redmine - Feature #13919: Mention user on issues and wiki pages us... Closed

Related to Redmine - Feature #26127: Display user logins on profiles Closed

Related to Redmine - Patch #26188: Documentation (detailed syntax help & code... Closed

Related to Redmine - Defect #26443: User link syntax (user:login) doesn't wor... Closed

Related to Redmine - Defect #26892: Link to user in wiki syntax only works wh... Closed

Has duplicate Redmine - Patch #6690: Redmine link to user profile Closed 2010-10-18

Associated revisions

Revision 16636 - 2017-06-07 22:10 - Jean-Philippe Lang

Link to user in wiki syntax (#4179).

Patch by Marius BALTEANU.

Revision 16638 - 2017-06-07 22:21 - Jean-Philippe Lang

Fixes wrong condition (#4179).

Revision 16671 - 2017-06-17 10:48 - Jean-Philippe Lang

Link to user by id (#4179).

Patch by Marius BALTEANU.

History

#1 - 2010-01-21 15:53 - Victor Dulepov

My vote goes for this feature. Got used to that in Confluence...

#2 - 2010-02-09 14:07 - Angelo Quaglia

It would be very useful, I agree.

#3 - 2011-02-28 16:54 - Dominic Clifton

+1

#4 - 2011-06-10 17:33 - Roman Surikov

+1

#5 - 2011-10-07 11:28 - Jose Mari M

+1

#6 - 2011-12-02 09:06 - Jonathan East
+1

#7 - 2012-01-05 02:26 - Dongju Kim

+1

#8 - 2012-02-02 08:54 - Ming-Chin Chen

+1

#9 - 2012-02-02 09:45 - Anonymous

+1

#10 - 2012-02-08 03:39 - Namho Kim

+1

#11 - 2012-02-15 17:11 - Anonymous

+1

#12 - 2012-06-25 19:31 - Roberto  Almeida Quilice Longhi

+1

#13 - 2012-06-26 11:26 - Jose Mari M

+1

#14 - 2012-08-03 13:33 - Rainer Putzinger

+1

#15 - 2012-08-24 15:39 - José Campos

+1

#16 - 2012-10-31 11:29 - Guilherme Andrade Del Cantoni

+1

#17 - 2012-11-20 01:30 - Andriy Lesyuk

Just wanted to let you know, that it has been implemented in WikiNG...

#18 - 2013-01-21 18:43 - Thomas Robbs

+1

#19 - 2013-03-17 05:45 - Mischa The Evil

- Target version set to Unplanned backlogs

#20 - 2013-05-01 03:05 - Diego Antunes

+1, but please check this link http://www.redmine.org/issues/13919

#21 - 2013-05-21 12:37 - Mariusz Dalewski

+1

#22 - 2013-05-29 10:39 - Jaroslav Povolný

My +1 here. The most nice would be to use twitter-like annotation: Felix Schäfer

#23 - 2013-08-27 17:39 - Julien Huang

+1 for Twitter-like user-mention (see also #13919)

Also, this feature raises the issue about notification when a user is mentioned in an issue/wiki page/commit msg...

#24 - 2013-09-21 17:23 - Toshi MARUYAMA

- Has duplicate deleted (Patch #6690: Redmine link to user profile)
#25 - 2013-09-21 17:23 - Toshi MARUYAMA

- Related to Patch #6690: Redmine link to user profile added

#26 - 2013-12-24 13:24 - Hugo da Silva da Silva

+1

This would be very useful for me too. It would be nice if I could create the RACI Matrix and reference eache person by their own users page.

#27 - 2014-01-16 12:51 - Anonymous

+1

#28 - 2014-04-07 20:44 - Lucky Boy

+1

#29 - 2014-04-16 16:55 - Jaromír Rys

+1

#30 - 2014-05-27 16:00 - Kevin Palm

+1

#31 - 2014-09-26 11:39 - Jurgen Reniers

+1

#32 - 2014-10-22 03:31 - Stephane Lapie

+1

#33 - 2015-01-16 17:06 - Dmitry Rizhikov

+1

#34 - 2015-03-23 18:12 - Moisés Bites

+1

#35 - 2015-05-11 14:41 - Michal Kowalski

+1

#36 - 2015-11-16 02:22 - John Wang

+1

#37 - 2016-02-12 14:09 - Wolfi F.

+1

#38 - 2016-09-21 14:29 - Matthias Pohl

+1

#39 - 2016-09-21 15:04 - Toshi MARUYAMA

- Category changed from Wiki to Text formatting

#40 - 2016-12-19 16:49 - Jonatã Bolzan Loss

+1

#41 - 2017-05-07 14:17 - Marius BĂLTEANU

- File 4179_link_to_user_in_wiki_syntax.patch added

I've attached a patch that adds two syntaxes for user links:

Marius BĂLTEANU

Marius BĂLTEANU

Users privacy is checked by this patch.

Regarding the proposed syntax with id (user:107353), even if it's easy to be added, I think that it is not worth it because is hard to retain the ids. For
example, I don't know my user id from the instance that I administrate for more than 3 years.

Even if the syntax with @ required some changes in the wiki formatting (to support logins name with @), I really think that is it important to have it

because the syntax "@user" is very well known and used by many applications (like: Github, Gitlab, etc).

This is another top voted feature, maybe we can include this in 3.4.0 in order to work at the mention feature (#13919) in version:3.5.0. These 2

features will improve the collaboration level.

#42 - 2017-05-09 16:47 - Go MAEDA

Marius BALTEANU, thank you for the patch. I really want this feature.

But I am not certain about whether the proposed implementation is proper or not because User#login is treated as secret information in the current

implementation of Redmine. Please see source:trunk/app/views/users/show.html.erb@16464#L9. Only admin can see User#login.

#43 - 2017-05-09 21:37 - Marius BĂLTEANU

Unfortunately, I don't see to many alternatives for the implementation:

1. First Name and Last Name cannot be used, it is hard to find a user after these properties and also, they are not unique.

2. ID could be a solution, but without an autocomplete feature to search users like in the watchers modals it'll be hard to find their ids. Also, I find it

quite strange to see "user:107353" in texts comments/wikis.

3. Email addresses, but the users have the option to hide this attribute.

From my point of view, User#login is the best solution and I do not see to many disadvantages because:

- in many companies, you can easily guess the login name of your colleagues because they have the same format

- comparing with the Last Name, First Name or the email addresses, it is less considered personal data.

Of course, if you get the login name of another user, you can try some brute force to login with his user, but this "security" issue can be prevented

using a mechanism like Captcha.

@Go Maeda, how do you see this implementation? I'm open to create a patch only with "user:id", but I want some feedback before.  In this note (

#6690#note-2), Jean-Philippe Lang said only about the user.visible? check that wasn't implemented in the respective patch.

#44 - 2017-05-12 04:49 - Go MAEDA

- Target version changed from Unplanned backlogs to Candidate for next major release

Marius BALTEANU wrote:

@Go Maeda, how do you see this implementation? I'm open to create a patch only with "user:id", but I want some feedback before.  In this note

(#6690#note-2), Jean-Philippe Lang said only about the user.visible? check that wasn't implemented in the respective patch.

 I prefer using User#login as you suggested but it violates current design.

I think we should change current design of Redmine. That is, Stop handling user#login as secret information. Personally I don't think User#login as

confidential. Many services treats user id as public.

#45 - 2017-05-12 09:29 - Marius BĂLTEANU

Go MAEDA wrote:

I prefer using User#login as you suggested but it violates current design.

I think we should change current design of Redmine. That is, Stop handling user#login as secret information. Personally I don't think User#login

as confidential. Many services treats user id as public.

 Totally agree. I'm going to update the patch this weekend and after that, we'll see what Jean-Philippe Lang says about this change.

#46 - 2017-05-12 09:52 - Jan from Planio www.plan.io

I think it's fine to not hide login names. I would think that users don't expect logins to be secret/personal today. And I also like the feature ;-)

#47 - 2017-05-13 17:33 - Marius BĂLTEANU

- File 4179_show_login_attribute_in_user_page.patch added

Thanks Go MAEDA and Jan for your feedback. I've attached a new patch that shows the login attribute in user page also for non admin users.

If the patch will be accepted, we can implement also #5228.

#48 - 2017-05-13 17:36 - Marius BĂLTEANU

- File 4179_show_login_attribute_in_user_page_v2.patch added
Attached the correct one. Please remove attachment:4179_show_login_attribute_in_user_page.patch.

#49 - 2017-05-14 07:34 - Jan from Planio www.plan.io

- File deleted (4179_show_login_attribute_in_user_page.patch)

#50 - 2017-05-14 08:38 - Go MAEDA

Marius BALTEANU wrote:

Thanks Go MAEDA and Jan for your feedback. I've attached a new patch that shows the login attribute in user page also for non admin users.

 Thanks for working on this. I found that we also have to change the behavior of API.

diff --git a/app/views/users/show.api.rsb b/app/views/users/show.api.rsb

index e4c49f9b8..e711bc482 100644

--- a/app/views/users/show.api.rsb

+++ b/app/views/users/show.api.rsb

@@ -1,6 +1,6 @@

 api.user do

   api.id         @user.id

-  api.login      @user.login if User.current.admin? || (User.current == @user)

+  api.login      @user.login

   api.firstname  @user.firstname

   api.lastname   @user.lastname

   api.mail       @user.mail if User.current.admin? || !@user.pref.hide_mail

#51 - 2017-05-14 09:17 - Marius BĂLTEANU

- File 4179_show_login_attribute_in_user_show_v3.patch added

Indeed. Thanks for pointing this out.

Updated the patch to include this change and also to fix the tests.

#52 - 2017-05-20 07:00 - Go MAEDA

- Target version changed from Candidate for next major release to 3.4.0

This issue has many "+1"s and watchers. Many people want this feature.

I am setting target version to 3.4.0.

#53 - 2017-06-01 23:56 - Mischa The Evil

Marius BALTEANU wrote:

Regarding the proposed syntax with id (user:107353), even if it's easy to be added, I think that it is not worth it because is hard to retain the ids.

For example, I don't know my user id from the instance that I administrate for more than 3 years.

I agree that an implementation based on User#login is ok

1

, but I also like to second the above quote, for two reasons:

1. many people (including myself) do rely on the usage of user ids (they are easily retrievable — also for non-admins — by looking at the target of

the linked [to users profile] username)

2. it would make it more consistent with the existing Redmine links which all accept an id variant

1

 I do however see the issue that with opening up the users' login, we make it easier for bad adversaries to bruteforce user account passwords. This

might be considered a blocker for some users...

#54 - 2017-06-07 08:43 - Marius BĂLTEANU

Thanks for you feedback.

Mischa The Evil wrote:

I agree that an implementation based on User#login is ok

1

, but I also like to second the above quote, for two reasons:

1. many people (including myself) do rely on the usage of user ids (they are easily retrievable — also for non-admins — by looking at the

target of the linked [to users profile] username)

2. it would make it more consistent with the existing Redmine links which all accept an id variant

 We can do it, I'll add a new patch soon to add the functionality also for ids.
1

 I do however see the issue that with opening up the users' login, we make it easier for bad adversaries to bruteforce user account passwords.

This might be considered a blocker for some users...

 Agree with you, but the solution for this problem is not to hide the login names (which are easily to guess in many companies), but to use a

mechanism like Captcha (see my note #4179#note-43) which could be very useful on this site too.

#55 - 2017-06-07 22:16 - Jean-Philippe Lang

- Subject changed from Link to user in wiki syntax. to Link to user in wiki syntax

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

The patch that adds support for links to user is committed, thanks.

But I prefer to postpone the display of user logins on profiles until we get more feedback. Those who are fine with this can still use logins as display

names right now.

#56 - 2017-06-08 09:04 - Marius BĂLTEANU

- File link_to_user_profile_by_id.patch added

@Jean-Philippe Lang, thanks for committing this patch.

Mischa The Evil The Evil, I've attached the patch that adds support also for ingo denner (user:1).

#57 - 2017-06-08 15:12 - André Lozovey

In my company we have firstname.lastname as a default for user logins. Nevertheless, we have a wiki page that lists all logins so we can mention

them if anyone forgets anything.

As you can see, we don't think displaying user logins is such a problem. I understand it could be a security issue, but I'm not worried about that. We

encourage people to change passwords every now and then.

Jean-Philippe Lang wrote:

The patch that adds support for links to user is committed, thanks.

But I prefer to postpone the display of user logins on profiles until we get more feedback. Those who are fine with this can still use logins as

display names right now.

#58 - 2017-06-09 07:54 - Mischa The Evil

- Related to deleted (Patch #6690: Redmine link to user profile)

#59 - 2017-06-09 07:54 - Mischa The Evil

- Has duplicate Patch #6690: Redmine link to user profile added

#60 - 2017-06-09 08:33 - Mischa The Evil

Jean-Philippe Lang wrote:

The patch that adds support for links to user is committed, thanks.

 I'm glad to see this integrated. However, the current implementation is practically useless to all sites that use a user format (display name) other than

the one consisting of the user login, as (regular) users won't be able to retrieve the user logins under such circumstances. This can be prevented by

also adding support for a numerical variant of the link (ingo denner or more preferable user#id) like eg. provided by Marius' additional patch attached

in note-56. Would you please consider that for inclusion into 3.4.0?

Jean-Philippe Lang wrote:

But I prefer to postpone the display of user logins on profiles until we get more feedback. [...]

 I have opened #26127 to track that specific proposal.

#61 - 2017-06-09 08:43 - Mischa The Evil

Marius BALTEANU wrote:
Mischa The Evil The Evil, I've attached the patch that adds support also for ingo denner (user:1).

 Thanks. I've had a look at it and it seems okay. One note though: all link keywords that take a numerical id are using # as the separator whereas the

ones that take a name, instead use the : separator. With your patch (as also proposed by the OP of this issue) we diverge from this convention.

Maybe it's better to use user#id along with user:login and @login. What do you think?

#62 - 2017-06-09 08:44 - Mischa The Evil

- Related to Feature #26127: Display user logins on profiles added

#63 - 2017-06-15 13:44 - Mischa The Evil

- Status changed from Closed to Reopened

Reopened in light of note-60.

#64 - 2017-06-15 14:04 - Marius BĂLTEANU

Mischa The Evil wrote:

Thanks. I've had a look at it and it seems okay. One note though: all link keywords that take a numerical id are using # as the separator whereas

the ones that take a name, instead use the : separator. With your patch (as also proposed by the OP of this issue) we diverge from this

convention. Maybe it's better to use user#id along with user:login and @login. What do you think?

 I agree with you, I'll update the patch to use the # as separator.

#65 - 2017-06-16 00:13 - Marius BĂLTEANU

- File link_to_user_profile_by_id_v2.patch added

Here it is.

#66 - 2017-06-16 06:44 - Mischa The Evil

Marius BALTEANU wrote:

Here it is.

 Nice. LGTM! Thanks for working on this.

@Jean-Philippe: I think that this issue would be completely implemented for 3.4.0 when note-65 (instead of note-56) patch gets integrated along with 

r16636 and r16638. Please consider the integration of this last patch.

#67 - 2017-06-17 10:48 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Thanks.

#68 - 2017-06-18 13:53 - Mischa The Evil

- Related to Patch #26188: Documentation (detailed syntax help & code) additions/improvements added

#69 - 2017-07-11 10:24 - Vu Anh

Seem it isn't working well with syntax "user:abc@example.com" (Login name contain "@" character)

#70 - 2017-07-11 10:30 - Go MAEDA

Vu Anh wrote:

Seem it isn't working well with syntax "user:abc@example.com" (Login name contain "@" character)

 This issue has been closed and the feature has already been delivered. Could you open a new issue to report the problem?

#71 - 2017-07-14 21:22 - Mischa The Evil

- Related to Defect #26443: User link syntax (user:login) doesn't work for logins consisting of an email adress added
#72 - 2017-07-14 21:27 - Mischa The Evil

Go MAEDA wrote:

Vu Anh wrote:

Seem it isn't working well with syntax "user:abc@example.com" (Login name contain "@" character)

 This issue has been closed and the feature has already been delivered. Could you open a new issue to report the problem?

 Done. #26443.

@Vu Anh: you can alternatively use the short syntax (@abc@example.com), which should work fine.

#73 - 2017-09-24 13:46 - Go MAEDA

- Related to Defect #26892: Link to user in wiki syntax only works when login is written in lower case added

Files

4179_link_to_user_in_wiki_syntax.patch 7.25 KB 2017-05-07 Marius BĂLTEANU

4179_show_login_attribute_in_user_page_v2.patch 553 Bytes 2017-05-13 Marius BĂLTEANU

4179_show_login_attribute_in_user_show_v3.patch 2.29 KB 2017-05-14 Marius BĂLTEANU

link_to_user_profile_by_id.patch 1.43 KB 2017-06-08 Marius BĂLTEANU

link_to_user_profile_by_id_v2.patch 1.66 KB 2017-06-15 Marius BĂLTEANU
